/* slurp-example-application.c
 *
 * Copyright (C) 2017 Julian Richen
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#define G_LOG_DOMAIN "slurp-example-application"

#include <gtk/gtk.h>

#include <slurp/slurp.h>
//#include <slurp-gtk/slurp-gtk.h>
/*
static void
progress_cb (void)
{
    g_print ("Progress...");
}

static void
finished_cb (void)
{
    g_print ("Progress...");
}
*/
static void
activate (GtkApplication *application,
          gpointer        user_data)
{
    GtkWidget *window;
    GtkWidget *headerbar;

    window = gtk_application_window_new (application);
    gtk_window_set_title (GTK_WINDOW (window), "Slurp Example");
    gtk_window_set_default_size (GTK_WINDOW (window), 320, 480);

    headerbar = gtk_header_bar_new ();
    gtk_header_bar_set_show_close_button (GTK_HEADER_BAR (headerbar), TRUE);
    gtk_header_bar_set_title (GTK_HEADER_BAR (headerbar), "Slurp Example");
    gtk_window_set_titlebar (GTK_WINDOW (window), headerbar);

    GtkWidget *progress = gtk_label_new ("0");
    gtk_container_add (GTK_CONTAINER (window), progress);


    SlurpResource *resource = NULL;
    GCancellable *cancellable = NULL;
    GError *error = NULL;
    gchar *source;
    gchar *target;
    gchar *overwrite;

    source = "https://www.google.com/images/branding/googlelogo/1x/googlelogo_color_272x92dp.png";
    target = "/home/julian/Downloads/temp/";
    overwrite = FALSE;

    GFile *file = g_file_new_for_uri ("aasd-123\asd^%&&*IO()_asd");
    g_print ("%s\n\n", g_file_get_parse_name (file));
    g_object_unref (file);

    resource = g_object_new (SLURP_TYPE_RESOURCE,
                             "source", g_strdup (source),
                             "target", g_strdup (target),
                             "overwrite", overwrite,
                             NULL);
    cancellable = g_cancellable_new ();

    g_print ("SOURCE: %s\n", slurp_resource_get_source (resource));
    g_print ("TARGET: %s\n", slurp_resource_get_target (resource));

    if (!slurp_resource_is_valid (resource, cancellable, &error))
    {
        g_print ("Error: %s", error->message);

        g_object_unref (resource);
    }

    //SlurpDownload *download = slurp_download_new ();
    //slurp_download_resource_async (download, resource);

    //g_free (source);
   // g_free (target);

/*
    SlurpDownload *slurp;
    GCancellable *cancellable;
    //SlurpWidget *slurp_widget;
    slurp = slurp_download_new ();
    cancellable = g_cancellable_new ();

    slurp_download_add_uri_full (slurp,
                                "https://www.google.com/images/branding/googlelogo/1x/googlelogo_color_272x92dp.png",
                                 NULL,
                                 FALSE,
                                 cancellable,
                                 progress_cb,
                                 application);




    slurp_download_add_uri (slurp,
                            "https://www.google.com/images/branding/googlelogo/1x/googlelogo_color_272x92dp.png",
                            cancellable);

    slurp_download_add_uri (slurp,
                            "http://community.edgecast.steamstatic.com/public/shared/images/header/globalheader_logo.png",
                            NULL);

    slurp_download_add_uri (slurp,
                            "https://s.imgur.com/desktop-assets/desktop-assets/Navbar-logo.bcf646386406b43008da913e901b916d.svg",
                            NULL);

    slurp_download_add_uri_full (slurp,
                                 "https://download.fedoraproject.org/pub/fedora/linux/releases/27/Workstation/x86_64/iso/Fedora-Workstation-Live-x86_64-27-1.6.iso",
                                 NULL,
                                 FALSE,
                                 NULL,
                                 progress_cb,
                                 application);
*/
    //progress

    //slurp_widget = slurp_widget_new ();
    //gtk_container_add (GTK_CONTAINER (window), slurp_widget);

    gtk_widget_show_all (window);
}

int
main (int    argc,
      char **argv)
{
    GtkApplication *application;
    int status;

    application = gtk_application_new ("org.gnome.slurp.application",
                                       G_APPLICATION_FLAGS_NONE);

    g_signal_connect (application, "activate", G_CALLBACK (activate), NULL);

    status = g_application_run (G_APPLICATION (application), argc, argv);

    g_object_unref (application);

    return status;
}
